                  PROGRAM
                  MAP
                  END

BackupLog           FILE,DRIVER('TOPSPEED'),NAME('BackupLog.tps'),PRE(Bkl)
KeyDate               KEY(-Bkl:Date,+Bkl:Time),DUP,OPT,NOCASE
KeyFromFolder         KEY(+Bkl:FromFolder,-Bkl:Date),DUP,OPT,NOCASE
RECORD                RECORD
Date                    LONG
Time                    LONG
Files                   DECIMAL(5,0)
Bytes                   DECIMAL(11,0)
Elapsed                 LONG
FromFolder              STRING(80)
ToFolder                STRING(80)
                      END
                    END
BackupSites         FILE,DRIVER('TOPSPEED'),NAME('BackupSites'),CREATE,PRE(Bks)
KeyFromFolder         KEY(+Bks:FromFolder),DUP,OPT,NOCASE
KeySiteName           KEY(+Bks:SiteName),OPT,NOCASE
RECORD                RECORD
SiteName                STRING(8)
FromFolder              STRING(80)
ToFolder                STRING(80)
                      END
                    END

Loc:FileName         STRING(80)
Loc:FileSize         LONG
Loc:FileDate         LONG
Loc:StartTime        LONG
PercentProgress      BYTE
RecordsProcessed     SHORT
RecordsToProcess     SHORT
Progress:Thermometer BYTE

DataFiles      QUEUE(File:queue),PRE(Dat)
               END

NewFiles       QUEUE(File:queue),PRE(New)
               END

Progress WINDOW('Backup Data Files'),AT(,,259,145),FONT('MS Sans Serif',8,,),IMM,TIMER(100),SYSTEM,DOUBLE
       PROMPT('This procedure copies the data files to the Backup Area computer.'),AT(25,15),TRN
       PROMPT('File Name:'),AT(50,35),USE(?Loc:FileName:Prompt)
       STRING(@s80),AT(90,35,161,10),USE(Loc:FileName)
       PROMPT('File Size:'),AT(55,48),USE(?Loc:FileSize:Prompt)
       STRING(@n10b),AT(90,48),USE(Loc:FileSize),LEFT
       PROMPT('Total:'),AT(155,48),USE(?Bkl:Bytes:Prompt)
       STRING(@n11b),AT(178,48),USE(Bkl:Bytes),LEFT
       PROMPT('File Date:'),AT(53,62),USE(?Loc:FileDate:Prompt)
       STRING(@d2b),AT(90,62),USE(Loc:FileDate),LEFT
       PROMPT('From Folder:'),AT(45,77),USE(?Bkl:FromFolder:Prompt)
       STRING(@s80),AT(90,77,164,10),USE(Bkl:FromFolder),LEFT
       PROMPT('To Folder:'),AT(51,91),USE(?Bkl:ToFolder:Prompt)
       STRING(@s80),AT(90,91,166,10),USE(Bkl:ToFolder),LEFT
       STRING(''),AT(40,125,179,10),USE(?Progress:PctText),CENTER
       PROGRESS,USE(Progress:Thermometer),AT(22,113,212,8),RANGE(0,100)
     END

  CODE
  SHARE(BackupLog)
  CASE ERRORCODE()
  OF 0
  OF 2
    CREATE(BackupLog)
    OPEN(BackupLog)
  ELSE
    MESSAGE('Error = ' & ERRORCODE() & ': ' & ERROR(),'OPEN(BackupLog)',ICON:Exclamation)
    RETURN
  END

  SHARE(BackupSites)
  IF ERRORCODE()
    MESSAGE('Error = ' & ERRORCODE() & ': ' & ERROR(),'OPEN(BackupSites)',ICON:Exclamation)
    RETURN
  END
  SET(BackupSites)
  LOOP
    NEXT(BackupSites)
    IF ERRORCODE() THEN BREAK.

    Loc:StartTime = CLOCK()
    CLEAR(Bkl:Record)
    Bkl:Date = TODAY()
    Bkl:Time = CLOCK()
    IF SUB(CLIP(Bkl:FromFolder),-1,1) = '\'
      Bkl:FromFolder = Bks:FromFolder
    ELSE
      Bkl:FromFolder = CLIP(Bks:FromFolder) & '\'
    END
    IF SUB(CLIP(Bkl:ToFolder),-1,1) = '\'
      Bkl:ToFolder = CLIP(Bks:ToFolder) & FORMAT(TODAY(),@d11)
    ELSE
      Bkl:ToFolder = CLIP(Bks:ToFolder) & '\' & FORMAT(TODAY(),@d11)
    END

    OPEN(Progress)
    PercentProgress = 0
    Progress:Thermometer = 0
    ?Progress:PctText{Prop:Text} = '0% Completed'
    
    !MESSAGE('Bkl:ToFolder = ' & Bkl:ToFolder,'File Name',ICON:Asterisk)
    RUN('cmd /c MD ' & '"' & CLIP(Bkl:ToFolder) & '"', 1)
    IF RUNCODE() > 1
      MESSAGE('Folder = ' & CLIP(Bkl:ToFolder) & |
        '|RUNCODE() = ' & RUNCODE() & |
        '|ERRORCODE() = ' &  ERRORCODE() & |
        '|ERROR() = ' &  ERROR(),'MD Today()',ICON:Exclamation)
      !RETURN
    END

    DIRECTORY(DataFiles,CLIP(Bkl:FromFolder) & '*.tps',ff_:Normal)
    DIRECTORY(NewFiles,CLIP(Bkl:ToFolder) & '\*.tps',ff_:Normal)

    Bkl:Bytes = 0
    RecordsProcessed = 0
    RecordsToProcess = RECORDS(DataFiles)

    SORT(DataFiles,Dat:Name)
    SORT(NewFiles,New:Name)

    LOOP J# = 1 TO RecordsToProcess
      GET(DataFiles,J#)
      Loc:FileName = Dat:Name
      Loc:FileSize = Dat:Size
      Loc:FileDate = Dat:Date    
      Bkl:Bytes += Dat:Size

      RecordsProcessed += 1
    
      New:Name = Dat:Name
      GET(NewFiles,New:Name)
      CASE ERRORCODE()
      OF 0
        IF New:Date >= Dat:Date
          CYCLE
        END
      OF 30 ! Not Found
        !MESSAGE('New:Name = ' & New:Name & |
        !  '|Dat:Name = ' & Dat:Name & |
        !  '|Errorcode = ' & ERRORCODE() & ': ' & ERROR() & |
        !  '|RECORDS() = ' & RECORDS(NewFiles) & |
        !  '|Bkl:ToFolder = ' & Bkl:ToFolder,'File Name',ICON:Asterisk)
      END
    
      IF PercentProgress < 100
        PercentProgress = (RecordsProcessed / RecordsToProcess)*100
        IF PercentProgress > 100
          PercentProgress = 100
        END
        IF PercentProgress <> Progress:Thermometer THEN
          Progress:Thermometer = PercentProgress
          ?Progress:PctText{Prop:Text} = FORMAT(PercentProgress,@N3) & '% Completed'
        END
      END
    
      COPY(CLIP(Bkl:FromFolder) & Dat:Name, Bkl:ToFolder)
      CASE ERRORCODE()
      OF 0
      ELSE
        MESSAGE('Error = ' & ERRORCODE() & ': ' & ERROR() & |
          '||Copy ' & CLIP(Bkl:FromFolder) & CLIP(Dat:Name) & |
          '|To ' & CLIP(Bkl:ToFolder), 'My Backup',ICON:Exclamation)
      END
    END
    
    FREE(DataFiles)
    FREE(NewFiles)

    Bkl:Files       = RecordsProcessed
    Bkl:Elapsed     = CLOCK() - Loc:StartTime
    ADD(BackupLog)
    IF ERRORCODE()
    !  MESSAGE('Error = ' & ERRORCODE() & ': ' & ERROR(), |
    !    'ADD(BackupLog)',ICON:Exclamation)
    END

    CLOSE(Progress)
  END

  CLOSE(BackupLog)
  CLOSE(BackupSites)
  IF ERRORCODE()
  END
  RETURN
